// C Source File
// Cree le 20/10/01; 14:41:13
// Auteur DOUALOT Nicolas

#define USE_TI92PLUS				// Produit .9xz File

#define OPTIMIZE_ROM_CALLS		// Use ROM Call Optimisation

#define SAVE_SCREEN          	// Save/Restore LCD Contents

#include <tigcclib.h>			// Inclue toute les librairies.
#define _height 64				//Taille d'une demi hauteur d'cran.
#define _width 120				//taille d'une demi longueur d'cran.
#define _left 337					//Valeur renvoye pour l'appuie sur gauche.
#define _right 340				//Valeur renvoye pour l'appuie sur droite.
#define _down 344					//Valeur renvoye pour l'appuie sur bas.
#define _up 338					//Valeur renvoye pour l'appuie sur haut.


//Dclaration des variables globales.
static unsigned short level=1, mode=1, points=15, position=1;

//Dfinition des sprites.
	//Sprite raquette gauche.
	static unsigned long sprtd[]={ 0x2, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x7, 0x2 };
	//Fin sprite raquette gauche.

	//Sprite raquette droite.
	static unsigned long sprtg[]={ 0x40000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0xE0000000, 0x40000000 };
	//Fin sprite raquette droite.

	//Sprite balle.
	static unsigned char sprtb[]={ 0x3C, 0x7E, 0xF7, 0xF3, 0xFF, 0xFF, 0x7E, 0x3C};
	//Sprite balle.

//Fin dfinition des sprites.

unsigned short scored, scoreg, quit;
//Fin de dclaration des variables globales.


//Fonction pour le dplacement de la balle.
void balle(unsigned char *sprtb, short *touche, short *bx, short *by, short *rdy, short *rgy, short *vx, short *vy)
{
	Sprite8(*bx, *by, 8, sprtb, LCD_MEM, SPRT_XOR);
	(*bx)+=*vx;									//Dplacement horizontal de la balle.
	(*by)+=*vy;									//Dplacement vertical de la balle.
	Sprite8(*bx, *by, 8, sprtb, LCD_MEM, SPRT_XOR);
	if (*bx-7==0 && *by-1<=*rgy+24 && *by+7>=*rgy)
	{
		*vx=1;									//Rebond si raquette gauche face  la balle.
		(*touche)++;							//Acclration du jeu.
	}
	if (*bx-2*_width+15==0 && *by-1<=*rdy+24 && *by+7>=*rdy)
	{
		*vx=-1;									//Rebond si raquette droite face  la balle.
		(*touche)++;							//Acclration du jeu.
	}
	if (*by==14) *vy=1;						//Rebond si balle en haut.
	if (*by==2*_height-16) *vy=-1;		// Rebond si balle en bas.
}
//Fin de la fonction pour le dplacement de la balle.



void cache(short x0, short y0, short x1, short y1, short mode)
{
	SCR_RECT zone;
	zone.xy.x0=x0;
	zone.xy.y0=y0;
	zone.xy.x1=x1;
	zone.xy.y1=y1;
	ScrRectFill(&zone, &zone, mode);
}





//Fonction pour le menu du jeu.
short intro(short a, BITMAP *intro_C0, BITMAP *intro_C1, unsigned short *level, unsigned short *mode, unsigned short *points, unsigned short *position)
{
	char copyright[38], lieu[6], modes[13], niveau[10], nombre[10];
	short key, h;
	clrscr();
	while(!IsGrayMode()) GrayMode(GRAY_ON);					//Activation des niveaux de gris.
	SetPlane(0);				//Activation du LIGHT_PLANE.
	clrscr();					//Effacement du plan.
	BitmapPut(_width-99, 2, intro_C0, &(SCR_RECT){{0,0,240,128}}, A_REPLACE);	//Affichage de l'image pour le LIGHT_PLANE.
	SetPlane(1);				//Activation du DARK_PLANE.
	clrscr();					//Effacement du plan.
	BitmapPut(_width-99, 2, intro_C1, &(SCR_RECT){{0,0,240,128}}, A_REPLACE);	//Affichage de l'image pour le DARK_PLANE.
	sprintf(copyright," Par DOUALOT Nicolas  DNDD.INC %c2001 ",169);	// caractre n169=
	FontSetSys(F_4x6);		//Petite police de caractres.
	DrawStrXY(_width-66, 2*_height-5, copyright, A_NORMAL);	//Affichage du copyright.
	
	//Si une partie vient de se terminer.
	if (a==1)
	{
		FontSetSys(F_8x10);	//Grande police de caractres.
		
		//Affiche si le joueur  perdu ou gagner ou que le matche est fini dans les autres cas.
		DrawStrXY(_width-46,70, (*position==0 || *position==3 ? "Fin du match" : (*position==1 ? scoreg : scored)==*points ? "Tu as gagn" : "Tu as perdu"), A_REPLACE);
		//Fin de l'affichage.
		
		FontSetSys(F_6x8);	//Moyenne police de caractres.
		
		//Affichage des scores.
		printf_xy( _width-60, 85, "%s: %d points.", (*position==0 || *position==2 ? "computer1" : "player_1 "), scoreg, A_REPLACE);
		printf_xy( _width-60, 95, "%s: %d points.", (*position==0 || *position==1 ? "computer2" : (*position==1 ? "player_1 " : "player_2 ")), scored, A_REPLACE);
		//Fin de l'affichage des scores.
		
		FontSetSys(F_4x6);	//Petite police de caractres.
		DrawStrXY( _width-56, 110,"[ENTER]=Rejouer ; [ESC]=Quitter", A_REPLACE);
		GKeyFlush();				//Effacement des touches appuyes.
		//Attente d'une touche.
		do
		{
			key=ngetchx();
		}
		while (key!=13 && key!=264);
		//Le joueur appui sur [ESC].
		if (key==264)
		{
			while(IsGrayMode()) GrayMode(GRAY_OFF);			//Dsactivation des niveaux de gris.
			return key;			//Retourne 264 pour pouvoir quitter le jeu.
		}
		//Fin du cas ou le joueur appui sur [ESC].
	}
	//Fin de ce cas.
	
	FontSetSys(F_6x8);		//Moyenne police de caractres.
	do
	{
		cache(_width-90, 65, _width+90, 120, 0);				//Efface  la position du menu.
		h=1;						//Choix en sur brillance.

		//Dessin des choix possible dans le menu principal.
		DrawStrXY( _width-39, 70, "Nouveau match", A_REPLACE);
		DrawStrXY( _width-21, 80, "Options", A_REPLACE);
		DrawStrXY( _width-12, 90, "Aide", A_REPLACE);
		DrawStrXY( _width-24, 100, "A propos", A_REPLACE);
		DrawStrXY( _width-21, 110, "Quitter", A_REPLACE);
		//Fin du dessin des choix possible dans le menu principal.

		cache(_width-46, 59+10*h, _width+46, 68+10*h, 2);	//Met en sur brillance la premire option.
		do
		{
			key=ngetchx();		//Attend l'appui sur un touche

			//Appui sur haut ou bas.
			if (key==_up || key==_down)
			{
				cache(_width-46, 59+10*h, _width+46, 68+10*h, 2);		//Dsactive la sur brillance de l'option qui tait active.
				if (key==_up)		//Appui sur haut.
				{
					h--;						//L'option au dessus est slectionne.
					h-1<0 ? h=5 : h;		//si la premire tait active on slectionne la dernire.
				}
				if (key==_down)	//Appui sur bas.
				{
					h++;						//L'option au dessous est slectionne.
					h-5>0 ? h=1 : h;		//Si la dernire tait active on slectionne la premire.
				}
				cache(_width-46, 59+10*h, _width+46, 68+10*h, 2);		//Active la sur brillance de la nouvelle option active.
			}
			//Fin du cas appui sur haut ou bas.
		}
		while(key!=13 && key!=264);	//On quitte la boucle si appui sur [ENTER] ou [ESC].
		if (h==5) key=264;				//Appui sur [ENTER], la dernire option tant active-> appui sur [ESC].
		
		//Si on appui sur [ENTER] on accde au niveau suivant du menu.
		if (key-13==0)
		{
			cache(_width-90, 65, _width+90, 120, 0);		//Effacement du menu principal.
			
			//Slection de l'option "Aide".
			if (h==3)
			{
				FontSetSys(F_8x10);
				DrawStrXY( _width-32, 70, "Touches:", A_REPLACE);
				FontSetSys(F_6x8);
				DrawStrXY( _width-78, 85, "\23,\24: Dplacer la raquette", A_REPLACE);
				DrawStrXY( _width-78, 95, "[APPS]  : Pause", A_REPLACE);
				DrawStrXY( _width-78, 105, "[ESC]   : Quitter le jeu.", A_REPLACE);
				do
				{
					key=ngetchx();
				}
				while( key!=13 && key!=264);
				key=0;
			}
			//Fin de l'aide.
			
			//Slection de l'option "A propos".
			if (h==4)
			{
				FontSetSys(F_8x10);
				DrawStrXY( _width-48, 70, "C-PONG v1.00", A_REPLACE);
				FontSetSys(F_6x8);
				DrawStrXY( _width-81, 85, "Ralisation DOUALOT Nicolas", A_REPLACE);
				DrawStrXY( _width-66, 95, "slubman@multimania.com", A_REPLACE);
				DrawStrXY( _width-87, 110, "Remerciements  la TIGCC team", A_REPLACE);
				do
				{
					key=ngetchx();
				}
				while( key!=13 && key!=264);
				key=0;
			}
			//Fin de l'option "A propos.
			
			//Slection de l'option "Options"->Ouverture du menu pour le rglage des options.
			//L'appui sur [ESC] ou sur [ENTER] permet de sauvegarder les rglages des options de jeu.
			if (h==2)
			{
				h=1;		//Choix slectionn.
				DrawChar(_width-52, 65+10*h, 17, A_NORMAL);
				DrawChar(_width+46, 65+10*h, 18, A_NORMAL);
				
				//Affichage des choix possibles dans le menu options, avec les dernier rglages mmoriss.

					//Affichage du mode de jeu.
					sprintf( modes, "%s", (*mode==0 ? "Humain:Humain" : (*mode==1 ? "Humain:TI" : "  TI:TI  ")));
					DrawStrXY( _width-3*strlen(modes), 75, modes, A_REPLACE);
					//Fin de l'affichage du mode de jeu.

					//Affichage du niveau de difficult.
					sprintf( niveau, "%s", (*level==0 ? "difficile" : (*level==1 ? "  normal  " : "  facile  ")));
					DrawStrXY( _width-3*strlen(niveau), 85, niveau, A_REPLACE);
					//Fin de l'affichage du niveau de difficult.

					//Affichage du nombre de points pour gagner un match.
					sprintf( nombre, "  %d points  ", *points);
					DrawStrXY( _width-3*strlen(nombre), 95, nombre, A_REPLACE);
					//Fin de l'affichage du nombre de points pour gagner un match.

					//Affichage de la position du joueur humain. Ce choix n'est possible qu'en mode "Humain:TI".
					sprintf( lieu, "%s", (*position==0 || *position==3 ? "......" : (*position==1 ? "gauche" : "droite")));
					DrawStrXY( _width-3*strlen(lieu), 105, lieu, A_REPLACE);
					//Fin de l'affichage de la position du joueur humain.

				//Fin de l'affichage des choix possible dans le menu options.
				
				cache(_width-46, 64+10*h, _width+46, 73+10*h, 2);		//Sur brillance du premier choix.
				do
				{
					//Affichage des flches  cot du rectangle.
					DrawChar(_width-52, 66+10*h, 17, A_NORMAL);
					DrawChar(_width+46, 66+10*h, 18, A_NORMAL);
					//Fin de l'affichage des flches  cot du rectangle.
					
					key=ngetchx();		//Attente de l'appui d'une touche.

					//Appui sur haut ou bas.
					if (key==_up || key==_down)
					{
						cache(_width-46, 64+10*h, _width+46, 73+10*h, 2);		//Dsactive la sur brillance de l'option qui tait active.
						//Effacement des flches.
						DrawChar(_width-52, 66+10*h, 32, A_REPLACE);
						DrawChar(_width+46, 66+10*h, 32, A_REPLACE);
						//Fin de l'effacement des flches.
						if (key==_up)			//Appui sur haut.
						{
							h--;						//L'option au dessus est slectionne.
							h-1<0 ? h=4 :h;		//si la premire tait active on slectionne la dernire.
							*mode !=1 && h==4 ? h=3 : h;	//Si le mode n'est pas "Humain:TI" on slectionne la troisime option.
						}
						if (key==_down)		//Appui sur bas.
						{
							h++;						//L'option au dessous est slectionne.
							h-(h==4 && *mode !=1 ? 3 : 4)>0 ? h=1 : h;
						}
						cache(_width-46, 64+10*h, _width+46, 73+10*h, 2);		//Active la sur brillance de la nouvelle option active.
					}
					
					// h=1->Rglage du mode de jeu.
					if (h==1)
					{
						if ( key==_left && *mode>0) (*mode)--;			//Appui sur gauche->mode prcdent.
						if ( key==_right && *mode<2) (*mode)++;		//Appui sur droite->mode suivant.
						*mode==0 ? *position=3 : *position;
						*mode==1 ? *position=1 : *position;
						*mode==2 ? *position=0 : *position;
						//Affichage du nouveau mode de jeu.
						sprintf( modes, "%s", (*mode==0 ? "Humain:Humain" : (*mode==1 ? "  Humain:TI  " : "  TI:TI  ")));
						DrawStrXY( _width-3*strlen(modes), 75, modes, A_REVERSE);
						//Fin de l'affichage du nouveau mode de jeu.

						//Active ou dsactive le choix de la position du joueur humain.
						sprintf( lieu, "%s", (*position==0 || *position==3 ? "......" : (*position==1 ? "gauche" : "droite")));
						DrawStrXY( _width-3*strlen(lieu), 105, lieu, A_REPLACE);
					}
					//Fin du rglage du mode de jeu.
					
					// h=2->Rglage du niveau de difficult.
					if (h==2)
					{
						if ( key==_left && *level<3) (*level)++;		//Appui sur gauche->niveau suivant.
						if ( key==_right && *level>0) (*level)--;		//Appui sur droite->niveau prcdent
						//Affichage du nouveau niveau de difficult.
						sprintf( niveau, "%s", (*level==0 ? "difficile" : (*level==1 ? "  normal  " : "  facile  ")));
						DrawStrXY( _width-3*strlen(niveau), 85, niveau, A_REVERSE);
						//Fin de l'affichage du nouveau niveau de difficult.
					}

					// h=3->Rglage du nombre de points pour gagner le match.
					if (h==3)
					{
						if (key==_left && *points>10) (*points)--;		//Appui sur gauche-> +1 point.
						if (key==_right && *points<21) (*points)++;		//Appui sur droite-> -1 point.
						//Affichage du nouveau nombre de points.
						sprintf( nombre, "%d points", *points);
						DrawStrXY( _width-3*strlen(nombre), 95, nombre, A_REVERSE);
						//Fin de l'affichage du nouveau nombre de points.
					}

					// h=4 et mode "Humain:TI" actif->Rglage de la position du joueur humain.
					if (h==4 && *mode==1)
					{
						if (key==_left && *position==2) (*position)--;	//Appui sur gauche->humain  gauche.
						if (key==_right && *position==1) (*position)++;	//Appui sur droite->humain  droite.
						//Affichage de la position du joueur humain.
						sprintf( lieu, "%s", *position==1 ? "gauche" : "droite");
						DrawStrXY( _width-3*strlen(lieu), 105, lieu, A_REVERSE);
						//Fin de l'affichage de la position du joueur humain.
					}
				}
				while( key-13!=0 && key-264!=0);		//Le menu est actif tant que l'on a pas appuy sur [ENTER] ou[ESC]
				key=0;		//Permettre le retour au menu principal.
			}
			//Fin du menu de rglage des options de jeu.
			
		}
		//Fin de l'appui sur [ENTER] dans le menu principal.

	}
	while (key-13!=0 && key-264!=0); //Boucle pour le menu principal
	while(IsGrayMode()) GrayMode(GRAY_OFF);		//Dsactivation des niveaux de gris.
	return key;			//Retourne la valeur de la touche appuye.
}
//Fin de la fonction pour l'introduction.



//Fonction pour le dplacement de la raquette
short raquette(short *touche, short *rdy, short *rgy, short *vx, short *vy, unsigned long *sprtd, unsigned long *sprtg, unsigned short *position, unsigned short *level)
{
	short i;
	i=(*level==0 ? 1000 : (*level==1 ? 2000 : 3000))-50* *touche;			//Renvoye par dfaut lorsque le joueur n'appui sue aucune touche.

	//Le joueur1 dplace sa raquette.
	if (*position!=0)
	{
		//Appui sur haut -> raquette monte.
		if ((_rowread(0x3FE)&0x20) && (*position==1 ? *rgy : *rdy)>14)
		{
			Sprite32((*position==1 ? 4 : 204), (*position==1 ? *rgy : *rdy), 24, (*position==1 ? sprtg : sprtd), LCD_MEM, SPRT_XOR);
			(*position==1 ? (*rgy) : (*rdy))--;
			Sprite32((*position==1 ? 4 : 204), (*position==1 ? *rgy : *rdy), 24, (*position==1 ? sprtg : sprtd), LCD_MEM, SPRT_XOR);
			i-=700;
		}
		//Fin de l'appui sur haut.
		
		//Appui sur bas -> raquette descend.
		if ((_rowread(0x3FE)&0x80) && (*position==1 ? *rgy : *rdy)<2*_height-31)
		{
			Sprite32((*position==1 ? 4 : 204),  (*position==1 ? *rgy : *rdy), 24, (*position==1 ? sprtg : sprtd), LCD_MEM, SPRT_XOR);
			(*position==1 ? (*rgy) : (*rdy))++;
			Sprite32((*position==1 ? 4 : 204),  (*position==1 ? *rgy : *rdy), 24, (*position==1 ? sprtg : sprtd), LCD_MEM, SPRT_XOR);
			i-=700;
		}
		//Fin de l'appui sur bas.
	}
	//Il a fini de la dplacer.

	//Le joueur2 dplace sa raquette .
	if (*position==3)
	{
		//Appui sur [F2] -> raquette descend.
		if ((_rowread(0x3EF)&0x10) && *rgy<2*_height-31)
		{
			Sprite32(4, *rgy, 24, sprtg, LCD_MEM, SPRT_XOR);
			(*rgy)++;
			Sprite32(4, *rgy, 24, sprtg, LCD_MEM, SPRT_XOR);
			i-=700;
		}
		//Fin de l'appui sur [F2].
		
		//Appui sur [F1] -> raquette monte.
		if ((_rowread(0x3BF)&0x10) && *rgy>14)
		{
			Sprite32(4, *rgy, 24, sprtg, LCD_MEM, SPRT_XOR);
			(*rgy)--;
			Sprite32(4, *rgy, 24, sprtg, LCD_MEM, SPRT_XOR);
			i-=700;
		}
		//Fin de l'appui sur [F1].
	}
	//Il a fini de la dplacer.

	//Test pour la mise en pause ou pour quitter le jeu.
	if (_rowread(0x2FF)&0x40) quit=1;	//Appui sur [ESC] -> Fin de la partie
	if (_rowread(0x37F)&0x40) off();		//Appui sur [APPS] -> mise en pause et extinction de la calculatrice(le prof arrive).
	//Fin du test pour la mise en pause ou pour quitter le jeu.

	//L'ordinateur1 dplace sa raquette normal.
	if (*position!=3)
	{
		//Computer1 fait descendre sa raquette.
		if (*vy==1 && (*position==1 ? *rdy : *rgy)<2*_height-31 && *vx==(*position==1 ? 1 : -1) && random(5)!=1)
		{
			Sprite32((*position==1 ? 204 : 4), (*position==1 ? *rdy : *rgy), 24, (*position==1 ? sprtd : sprtg), LCD_MEM, SPRT_XOR);
			(*position==1 ? (*rdy) : (*rgy))++;
			Sprite32((*position==1 ? 204 : 4), (*position==1 ? *rdy : *rgy), 24, (*position==1 ? sprtd : sprtg), LCD_MEM, SPRT_XOR);
		}
		//Fin de la descente.
		
		//Computer1 fait monter sa raquette.
		if (*vy==-1 && (*position==1 ? *rdy : *rgy)>14 && *vx==(*position==1 ? 1 : -1) && random(5)!=1)
		{
			Sprite32((*position==1 ? 204 : 4), (*position==1 ? *rdy : *rgy), 24, (*position==1 ? sprtd : sprtg), LCD_MEM, SPRT_XOR);
			(*position==1 ? (*rdy) : (*rgy))--;
			Sprite32((*position==1 ? 204 : 4), (*position==1 ? *rdy : *rgy), 24, (*position==1 ? sprtd : sprtg), LCD_MEM, SPRT_XOR);
		}
		//Fin de la monte.
	}
	//Il a fini aussi.

	//L'ordinateur2 dplace sa raquette .
	if (*position==0)
	{
		//Computer2 fait descendre sa raquette.
		if (*vy==1 && *rdy<2*_height-31 && *vx==1 && random(5)!=1)
		{
			Sprite32(204, *rdy, 24, sprtd, LCD_MEM, SPRT_XOR);
			(*rdy)++;
			Sprite32(204, *rdy, 24, sprtd, LCD_MEM, SPRT_XOR);
		}
		//Fin de la descente.
		
		//Computer2 fait monter sa raquette.
		if (*vy==-1 && *rdy>14 && *vx==1 && random(5)!=1)
		{
			Sprite32(204, *rdy, 24, sprtd, LCD_MEM, SPRT_XOR);
			(*rdy)--;
			Sprite32(204, *rdy, 24, sprtd, LCD_MEM, SPRT_XOR);
		}
		//Fin de la monte.
	}
	//Il a fini aussi.
	i<700 ? i=700 : i;	//Valeur pour rgler la vitesse du jeu
	return i;				//Retourne cette valeur.

}
//Fin de la fonction pour le dplacement de la raquette.



//Fonction pour le trac du cadre de jeu.
void trace(short *touche, short *bx, short *by, short *rdy, short *rgy, short *vx, short *vy, short *position)
{
	char score[5];
	clrscr();													//Efface l'cran.
	cache(0, 0, 2*_width, 2*_height, 1);		//Tout l'cran est noire.
	cache(2, 13, 2*_width-3, 2*_height-7, 0);		//La partie correspondant  l'aire de jeu est en blanc.

	*bx=_width-4;
	*by=quit=*touche=*vx=*vy=0;
	*rdy=*rgy=_height-13;
	while (*vx==0)
	{
		*vx=(random(3)-1);			// Dtermination alatoire de la direction de
		if ((*vx!=-1) && (*vx!=1)) *vx=0;		//la balle au premier coup/
	};
	while (*vy==0)
	{
		*vy=(random(3)-1);			// Dtermination alatoire de la direction de
		if ((*vy!=-1) && (*vy!=1)) *vy=0;		//la balle au premier coup.
	}
	while (*by-25<=0 && *by-25<=2*_height-26) *by=random(2*_height-27);

	//Diffrentes oprations avant le lancement du jeu.
	FontSetSys(F_8x10);		//Grande police de caractres.
	
	//Affichage des noms.
	DrawStrXY(2,1,(*position==0 || *position==2 ? "computer1" : "player_1"), A_REVERSE);
	DrawStrXY(2*_width-78,1,(*position==0 || *position==1 ? "computer2" : (*position==1 ? "player_1" : "player_2")), A_REVERSE);
	//Fin de l'affichage des noms.
	
	//Dessin de la balle et des raquettes.
	Sprite8(*bx, *by, 8, sprtb, LCD_MEM, SPRT_XOR);
	Sprite32(4, *rgy, 24, sprtg, LCD_MEM, SPRT_XOR);
	Sprite32(204, *rdy, 24, sprtd, LCD_MEM, SPRT_XOR);
	sprintf(score,"%d-%d", scoreg, scored);
	DrawStrXY(_width-4*strlen(score),1,score,A_REVERSE);
	//Fin du dessin de la balle et des raquettes.

	//Fin des oprations ncessaires au lancement du jeu.

}
//Fin de la fonction pour le trac du cadre de jeu.



//Fonction pour la gestion du score.
void score(short *scored, short *scoreg, short *bx, short *vx)
{
	char score[5];			//Chane de caractres pour le score.

	//Le joueur  gauche a rat la balle.
	if (*bx==6 && *vx==-1)
	{
		(*scored)++;		// +1 point pour le joueur de droite.
		quit=2;			//Fin de l'change.
	}
	//Fin du test pour le joueur  gauche.
	
	//Le joueur  droite a rat la balle.
	if (*bx==2*_width-14 && *vx==1)
	{
		(*scoreg)++;		// +1 point pour le joueur de gauche.
		quit=2;			//Fin de l'change.
	}
	//Fin du test pour le joueur  droite.

	sprintf(score,"%d-%d",*scoreg,*scored);					//prparation de l'affichage du score.
	FontSetSys(F_8x10);		//Grande police de caractres.
	DrawStrXY(_width-4*strlen(score),1,score,A_REVERSE);	//Affichage du score.
}
//Fin de la fonction pour la gestion du score.



// Main Function
void _main(void)
{
	//Dclaration des variables locale  _main.
	INT_HANDLER save_int_1;	//Variable pour la sauvegarde de l'auto int 1
	
	//Variables transmise aux fonctions.
	short attente, bx, by, i=0, rdy, rgy, touche, vx, vy;
	//attente: permet de rgler la vitesse de jeu.
	//bx, by: position de la balle suivant x et y.
	//i: variable polyvalente (boucle for...)
	//key: valeur de la touche appuye.
	//rdy, rgy: position verticale des raquettes ( gauche et  droite).
	//Touche: augmentation de la vitesse pendant le jeu.
	//vx, vy: sens de la balle suivant x et y.
	//Fin des variables transmise aux fonctions.
	
	//Fin de la dclaration des variables locale  _main.

	//Image d'introduction.

	//Plan LIGHT_PLANE.
	BITMAP *intro_C0=&(BITMAP){58,198,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x80,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6D,0x01,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5B,0x03,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFE,0x07,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xA3,0x1F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x76,0x1F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xFC,0x37,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xFF,0xFE,0x00,0x00,0x00,0x00,0x01,0xFF,0xFF,0xFF,0xF0,0x00,0x00,0x03,0x3C,0x75,0x8E,0x00,0x00,0x38,0x0F,0xFF,0xFF,0x80,0x7F,0xFF,0xFB,0x00,0x00,0x00,0x00,0x03,0xFF,0xFF,0xFF,0xD8,0x00,0x40,0x06,0x38,0xF5,0x9B,0x00,0x00,0x6C,0x1F,0xFF,0xFE,0xC0,0x7F,0xFF,0xF9,0x00,0x00,0x00,0x00,0x03,0xFF,0xFF,0xFF,0xC8,0x00,0x60,0x00,0x69,0xE5,0x9D,0x00,0x00,0x74,0x1F,0xFF,0xFE,0x40,0x7B,0xFF,0xFF,0x00,0x00,0x00,0x00,0x03,0xFE,0xFF,0xFF,0xF8,0x00,0xF0,0x00,0xC0,0xED,0x9D,0x80,0x00,0x74,0x1E,0xFF,0xFF,0xC0,0x77,0xFF,0xFE,0x00,0x00,0x00,0x00,0x01,0xFD,0xFF,0xFF,0xF8,0x01,0xE0,0x01,0xE1,0xC7,0x9D,0x80,0x00,0x74,0x1D,0xFF,0xFF,0x80,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x03,0x40,0x00,0xA1,0xC7,0x9D,0xC0,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x03,0xC0,0x01,0x0B,0xC5,0x9D,0x40,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x03,0xC0,0x03,0x8B,0x85,0x9D,0xA0,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x05,0xC2,0x03,0x8B,0x87,0x1D,0xA0,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x0F,0xC2,0x03,0x0E,0x87,0x1D,0xD0,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x17,0xC2,0x07,0x0A,0x87,0x1D,0xD0,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x37,0xC6,0x06,0x0F,0x07,0x1D,0xE8,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x3F,0xE4,0x04,0x0D,0x07,0x1D,0xE8,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x3F,0xE4,0x08,0x0D,0x07,0x1D,0xF4,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x7B,0x48,0x18,0x1E,0x07,0x1D,0x74,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x77,0x48,0x08,0x1A,0x06,0x1D,0x7A,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0xF8,0x5F,0xD8,0x10,0x1C,0x06,0x1D,0x3A,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0xFF,0xFF,0xF8,0xEF,0x90,0x10,0x38,0x06,0x1D,0x3D,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0xFF,0xFF,0xF8,0xD6,0x90,0x18,0x28,0x06,0x1D,0x1D,0x00,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0xFF,0xFF,0xC8,0x9E,0xB0,0x08,0x00,0x04,0x1D,0x1E,0x80,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0xFF,0xFF,0xD8,0x8F,0x33,0xFC,0x00,0x0C,0x1D,0x0E,0x80,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0xFF,0xFF,0xF0,0x8F,0x3F,0xFF,0x80,0x0C,0x1D,0x0F,0x40,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x8A,0x3F,0xFF,0xC0,0x0C,0x1D,0x07,0x40,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x0E,0x7F,0xFF,0xE0,0x18,0x1D,0x07,0xA0,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x1E,0xFF,0xFE,0xF0,0x38,0x1D,0x03,0xB0,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x1D,0xFF,0xFE,0xF8,0x30,0x1D,0x01,0xD0,0x74,0x1D,0x00,0x00,0x00,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x1F,0xFF,0xFE,0x7C,0x70,0x1D,0x01,0xD8,0x74,0x1D,0x00,0xFF,0xF0,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x1F,0xFF,0xFE,0x1E,0x60,0x1D,0x00,0xE8,0x74,0x1D,0x01,0xFF,0xD8,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0xC0,0x1D,0x00,0xEC,0x74,0x1D,0x01,0xFF,0xC8,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x1F,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x74,0x74,0x1D,0x01,0xFF,0xF8,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x76,0x74,0x1D,0x00,0xFF,0xF0,0x74,0x00,0x00,0x03,0xFF,0xFF,0xFE,0x00,0x1D,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x3A,0x74,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x07,0xFF,0xFF,0xFB,0x00,0x1D,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x3B,0x74,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x07,0xFF,0xFF,0xF9,0x00,0x1D,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x1D,0x74,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x07,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x1F,0xF4,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x03,0xFF,0xFF,0xFE,0x00,0x1D,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x0E,0xB4,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0x00,0x1D,0x00,0x0F,0x74,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x07,0xFF,0xFF,0xFE,0x00,0x1D,0x00,0x07,0xF4,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x07,0xFF,0xFF,0xFE,0x00,0x1D,0x00,0x07,0xF4,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x07,0xFF,0xFF,0xFE,0x00,0x1D,0x00,0x03,0xF4,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x03,0xFF,0xFF,0xFC,0x00,0x1D,0x00,0x03,0xF4,0x1D,0x00,0x07,0xC0,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1D,0x00,0x00,0x00,0x01,0xFF,0xFF,0xF8,0x00,0x1D,0x00,0x01,0xF4,0x1D,0x00,0x07,0xC0,0x77,0xFF,0xFE,0x00,0x00,0x00,0x00,0x03,0xFD,0xF8,0x00,0x00,0x00,0xFF,0xFF,0xF0,0x00,0x1D,0x00,0x01,0xF4,0x1D,0xFF,0xFF,0xC0,0x7B,0xFF,0xFF,0x00,0x00,0x00,0x00,0x07,0xFE,0xFC,0x00,0x00,0x00,0x7F,0xFF,0xE0,0x00,0x1D,0x00,0x00,0xF4,0x1E,0xFF,0xFF,0xC0,0x7F,0xFF,0xF9,0x00,0x00,0x00,0x00,0x07,0xFF,0xE4,0x00,0x00,0x00,0x3F,0xFF,0xC0,0x00,0x1D,0x00,0x00,0xF4,0x1F,0xFF,0xFE,0x40,0x7F,0xFF,0xFB,0x00,0x00,0x00,0x00,0x07,0xFF,0xEC,0x00,0x00,0x00,0x1F,0xFF,0x80,0x00,0x1B,0x00,0x00,0x6C,0x1F,0xFF,0xFE,0xC0,0x3F,0xFF,0xFE,0x00,0x00,0x00,0x00,0x03,0xFF,0xF8,0x00,0x00,0x00,0x03,0xFC,0x00,0x00,0x0E,0x00,0x00,0x38,0x0F,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}};

	//Plan DARK_PLANE.
	BITMAP *intro_C1=&(BITMAP){58,198,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBC,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xFE,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xFC,0x40,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xF8,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xF8,0x00,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xF8,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xF0,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xF0,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xE0,0x00,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xE0,0x00,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x01,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x01,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x03,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xC0,0x03,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x0F,0xE0,0x07,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x0F,0xB0,0x55,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x0F,0xFC,0xDF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x1F,0xFF,0xAF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x3F,0xFF,0xDB,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xE0,0x7F,0xFF,0xF7,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xE0,0xFF,0xFE,0xF7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x61,0xFF,0xFE,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xE3,0xFF,0xFE,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xE7,0xFF,0xFE,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xE7,0xFF,0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x67,0xFF,0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xEF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xEF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5F,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,0xFF,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xFF,0xFF,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0xFF,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}};

	//Fin de l'image d'introduction.

	//Vrification du type de calculatrice.
	
	//Fin de la vrification.
	if (LCD_WIDTH<240)
	{
		DlgMessage("Avertissement", "Ce jeu ne fonctionne que sur TI92+", BT_NONE, BT_NONE);
		return;
	}
	
	//Boucle permettant de recommencer la partie.
	do
	{

		//Menu de dbut de jeu et de fin de partie.
		if(intro(i, intro_C0, intro_C1, &level, &mode, &points, &position)==264) return;
		//Fin du menu de dbut de jeu et de fin de partie.

		//Initialisation des variables restantes.
		scored=scoreg=0;
		//Fin de l'initialisation des variables restantes.

		//Prparation pour l'utilisation de _rowread.
		save_int_1 = GetIntVec (AUTO_INT_1);
		SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
		//Fin de la prparation pour l'utilisation de _rowread.

		//dbut de la boucle permettant de jouer jusqu'au nombre de point pour gagner.
		do
		{
			trace(&touche, &bx, &by, &rdy, &rgy, &vx, &vy, &position);	//Trac du cadre de jeu.
			FontSetSys(F_6x8);		//Moyenne police de caractre.
			//Indication de la direction de la balle au lancement du jeu.
			DrawChar(_width-3, by-8,(vx==1 ? 22 : 21),A_REPLACE); 		//Direction de la balle au dbut.
			//Fin du dessin de l'indication au lancement de la balle.
			
			//Dlai de 3 secondes avant dbut de la partie.
			OSFreeTimer(6);
			OSRegisterTimer(6, 60);
			while (!OSTimerExpired(6))
			{
			i=OSTimerCurVal(6)/20+1;
			printf_xy(_width-3, by+10,"%d", i, A_REPLACE);
			//Test pour la mise en pause ou pour quitter le jeu.
			if (_rowread(0x2FF)&0x40) quit=1;	//appui sur [ESC]-> Retour au menu.
			if (_rowread(0x37F)&0x40) off();		//appui sur [APPS]-> Extinction de la calculatrice.
			//Fin du test pour la mise en pause ou pour quitter le jeu.
			}
			//Fin du dlai de 3 secondes.
			
			//Effacement des indicateurs au dbut de la partie.
			DrawChar(_width-3, by+10,32,A_REPLACE);
			DrawChar(_width-3, by-8,32,A_REPLACE);
			//Fin de l'effacement des indicateurs au dbut de la partie.
			
			
			//Boucle principale du jeu.
			do
			{
				score(&scored, &scoreg, &bx, &vx);			//Gestion du score
				attente=raquette(&touche, &rdy, &rgy, &vx, &vy, sprtd, sprtg, &position, &level);		//Gestion des raquettes
				for (i=0; i<=attente; i++);		//Dlai selon le niveau de difficult et le nombre de touches.
				balle(sprtb, &touche, &bx, &by, &rdy, &rgy, &vx, &vy);	//Gestion des dplacement de la balle.
			}
			while( quit==0 );
			//Fin de la boucle principale du jeu.
			
		if (quit==2) quit=0;

		}
		while (scoreg!=points && scored!=points && quit!=1);
		//Fin de la boucle permettant de jouer jusqu'au nombre de point pour gagner.
		
		//Arrt de l'utilisation de _rowread.
		SetIntVec (AUTO_INT_1, save_int_1);
		//Fin de l'arrt de l'utilisation de _rowread.

		i=1;
		quit=0;
	}
	while(1);
	//Fin de la boucle pour rejouer une partie.
}
